import 'option.dart';
import 'terminal.dart';

class Prompter {
  Prompter() {}

  final _terminal = const Terminal();

  bool askBinary(String prompt) {
    _ask("$prompt y/n", []);
    return _getBinaryInput();
  }

  Option askMultiple(String prompt, List<Option> options) {
    _ask(prompt, options);

    final option = _getInput(options);

    return option;
  }

  _ask(String prompt, List<Option> options) {
    _terminal.clearScreen();
    _terminal.printPrompt(prompt);
    _terminal.printOptions(options);
  }

  bool _getBinaryInput() {
    _terminal.printOptions([]);
    final input = _terminal.collectInput();
    if (input.contains('y')) {
      return true;
    } else if (input.contains('n')) {
      return false;
    }
    _terminal.clearScreen();
    _terminal.printPrompt("Invalid input try again");
    return _getBinaryInput();
  }

  Option _getInput(List<Option> options) {
    final input = _terminal.collectInput();
    final option = _getOptionsByLabel(input, options);
    if (option != null) {
      return option;
    }
    try {
      final index = int.parse(input);
      if (options.length > index && index >= 0) {
        _terminal.printPrompt("Answer ${options[index]}");
        return options[index];
      }
    } catch (_) {}
    _terminal.clearScreen();
    _terminal.printPrompt("Invalid options try again");
    return _getInput(options);
  }

  _getOptionsByLabel(String label, List<Option> options) {
    for (var option in options) {
      if (option.label == label) {
        return option;
      }
    }
    return null;
  }
}
