import 'dart:io';

import 'option.dart';

class Terminal {
  const Terminal(); //Const makes sure this is a singleton since we have no input params.

  void printPrompt(String question) {
    stdout.writeln(question);
  }

  void printOptions(List<Option> options) {
    options.asMap().forEach((index, option) {
      stdout.writeln("$index) ${option.label}");
    });

    stdout.writeln("Enter your choice\n");
    stdout.write(">");
  }

  String collectInput() {
    return stdin.readLineSync();
  }

  clearScreen() {
    if (Platform.isWindows) {
      stdout.write("\x1B[2J\x1B[0f");
    } else {
      stdout.write("\x1B[2J\x1B[3J\x1B[H");
    }
  }
}
